SystemOrganization addCategory: #PBE!
SystemOrganization addCategory: #'PBE-CIV'!
SystemOrganization addCategory: #'PBE-LightsOut'!
SystemOrganization addCategory: #'PBE-Monticello'!

Trait named: #TAuthor
	uses: {}
	category: 'PBE-LightsOut'!

!TAuthor commentStamp: '<historical>' prior: 0!
Following PBE.
!

!TAuthor methodsFor: 'accessing' stamp: 'AvramColak 12/4/2013 12:17'!
author
	"Returns author initials"
	^ 'ac' "Avram Colak"! !

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOCell commentStamp: '<historical>' prior: 0!
Following "Pharo by Example".!

!LOCell methodsFor: 'initialization' stamp: 'AvramColak 12/1/2013 15:07'!
initialize
	super initialize.
	self label:''.
	self borderWidth:2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff.! !

!LOCell methodsFor: 'accesing' stamp: 'AvramColak 12/1/2013 16:28'!
mouseAction: aBlock
	^ mouseAction := aBlock! !

!LOCell methodsFor: 'event handling' stamp: 'AvramColak 12/1/2013 16:31'!
mouseUp: anEvent
	mouseAction value! !

Object subclass: #Dog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-CIV'!

Dog class
	instanceVariableNames: 'count'!

!Dog commentStamp: '<historical>' prior: 0!
Following PBE.!

Dog class
	instanceVariableNames: 'count'!

Object subclass: #Hyena
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-CIV'!

!Hyena commentStamp: '<historical>' prior: 0!
Following PBE.
!

!Object methodsFor: '*PBE' stamp: 'AvramColak 12/4/2013 20:23'!
delicious
	^ 'probably not.'! !

Object subclass: #PBECrepes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-Monticello'!

!PBECrepes commentStamp: '<historical>' prior: 0!
Delicious.
!

!PBECrepes methodsFor: 'as yet unclassified' stamp: 'AvramColak 12/4/2013 19:23'!
delicious
	^ 'of course!!'! !

Object subclass: #PBEPancakes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-Monticello'!

!PBEPancakes commentStamp: '<historical>' prior: 0!
Delicious.
!

!PBEPancakes methodsFor: 'as yet unclassified' stamp: 'AvramColak 12/4/2013 19:24'!
delicious
	^ 'very!!'! !

Object subclass: #WebServer
	instanceVariableNames: 'sessions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-CIV'!

WebServer class
	instanceVariableNames: 'uniqueInstance'!

!WebServer commentStamp: '<historical>' prior: 0!
Following PBE.
!

WebServer class
	instanceVariableNames: 'uniqueInstance'!

!WebServer class methodsFor: 'accessing' stamp: 'AvramColak 12/3/2013 22:14'!
uniqueInstance
	uniqueInstance ifNil: [uniqueInstance := self new].
	^ uniqueInstance.! !

BorderedMorph subclass: #LOGame
	uses: TAuthor
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOGame commentStamp: '<historical>' prior: 0!
Following "Pharo by Example".
!

LOGame class
	uses: TAuthor classTrait
	instanceVariableNames: ''!

!LOGame methodsFor: 'initialization' stamp: 'AvramColak 12/1/2013 15:55'!
cellsPerSide
	"The number of cells along each side of the game"
	^ 10! !

!LOGame methodsFor: 'initialization' stamp: 'AvramColak 12/1/2013 16:20'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := LOCell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds:(5 @ 5 extent:( (width * n) @ (height * n) ) + (2 * self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ].
	! !

!LOGame methodsFor: 'event handling' stamp: 'AvramColak 12/1/2013 16:46'!
mouseMove: anEvent! !

!LOGame methodsFor: 'initialization' stamp: 'AvramColak 12/1/2013 21:02'!
newCellAt: i at: j
	"Create a cell for position (i,j) and add it to my on-screen representation at the appropriate screen position. Answer the new cell."
	| c origin |
	c := LOCell new.
	origin := self innerBounds origin.
	self addMorph:c.
	c position: ((i - 1) * c width) @ ((j - 1) * c height) + origin.
	c mouseAction: [ self toggleNeighboursOfCellAt: i at: j ].
	^ c! !

!LOGame methodsFor: 'game logic' stamp: 'AvramColak 12/1/2013 16:17'!
toggleNeighboursOfCellAt: i at: j
	(i > 1) ifTrue: [ (cells at: i - 1 at: j) toggleState ].
	(i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState ].
	(j > 1) ifTrue: [ (cells at: i at: j - 1) toggleState ].
	(j < self cellsPerSide) ifTrue: [ (cells at: i at: j + 1) toggleState ].
	! !
